# synfig::Module Class Reference

`#include <module.h>`

List of all members.

## Public Types

typedef etl::handle< Module > | Handle
typedef etl::loose_handle< Module > | LooseHandle
typedef etl::handle< const Module > | ConstHandle
typedef Module *(* | constructor_type )(ProgressCallback *)
typedef std::map< String, Handle > | Book

## Public Member Functions

bool | constructor_ (synfig::ProgressCallback *)
virtual void | destructor_ ()
virtual const char * | Name ()
virtual const char * | Desc ()
virtual const char * | Author ()
virtual const char * | Version ()
virtual const char * | Copyright ()
virtual | ~Module ()

## Static Public Member Functions

static Book & | book ()
static bool | subsys_init (const String &prefix)
static bool | subsys_stop ()
static void | register_default_modules (ProgressCallback *cb=NULL)
static void | Register (Handle mod)
static bool | Register (const String &module_name, ProgressCallback *cb=NULL)
static void | Register (Module *mod)

## Detailed Description

Todo:
  writeme

## Member Typedef Documentation

typedef etl::handle<Module> synfig::Module::Handle

typedef etl::loose_handle<Module> synfig::Module::LooseHandle

typedef etl::handle<const Module> synfig::Module::ConstHandle

typedef Module*(* synfig::Module::constructor_type)(ProgressCallback *)

typedef std::map<String, Handle > synfig::Module::Book

## Constructor & Destructor Documentation

virtual synfig::Module::~Module | ( |  | ) | `[inline, virtual]`

References destructor_().

## Member Function Documentation

bool synfig::Module::constructor_ | ( | synfig::ProgressCallback * |  | ) | `[inline]`

virtual void synfig::Module::destructor_ | ( |  | ) | `[inline, virtual]`

Referenced by ~Module().

Module::Book & Module::book | ( |  | ) | `[static]`

Referenced by process_global_flags(), and Register().

bool Module::subsys_init | ( | const String & | prefix | ) | `[static]`

References _, and synfig::error().

Referenced by synfig::Main::Main().

bool Module::subsys_stop | ( |  | ) | `[static]`

Referenced by synfig::Main::Main().

void Module::register_default_modules | ( | ProgressCallback * | cb = `NULL` | ) | `[static]`

References REGISTER_MODULE.

Referenced by synfig::Main::Main().

void synfig::Module::Register | ( | Module::Handle | mod | ) | `[static]`

References book().

Referenced by synfig::Main::Main(), and Register().

bool synfig::Module::Register | ( | const String & | module_name,
|  | ProgressCallback * | cb = `NULL` |
| ) |  |  | `[static]`

References _, synfig::ProgressCallback::error(), Register(), synfig::ProgressCallback::task(), and synfig::ProgressCallback::warning().

static void synfig::Module::Register | ( | Module * | mod | ) | `[inline, static]`

References Register().

virtual const char* synfig::Module::Name | ( |  | ) | `[inline, virtual]`

virtual const char* synfig::Module::Desc | ( |  | ) | `[inline, virtual]`

virtual const char* synfig::Module::Author | ( |  | ) | `[inline, virtual]`

virtual const char* synfig::Module::Version | ( |  | ) | `[inline, virtual]`

virtual const char* synfig::Module::Copyright | ( |  | ) | `[inline, virtual]`

References SYNFIG_COPYRIGHT.

The documentation for this class was generated from the following files:

- module.h
- module.cpp